#include <stdio.h>
#include <malloc.h>

#define FILE_CNT 7

int bgmtable[FILE_CNT][4]={
	//t@Cʒu@kTCY@𓀃TCY@ǋLp̕ϐ
	{0x184c276, 0x2999, 0x02a7a, 0x00},
	{0x1855471, 0x4c39, 0x097a9, 0x00},
	{0x184ec4d, 0x4933, 0x0b544, 0x00},

	{0x185a0aa, 0x5113, 0x0afdd, 0x00},
	{0x185f1bd, 0x6213, 0x0ee60, 0x00},
	{0x18653d0, 0x680c, 0x105d1, 0x00},

	{0x1853580, 0x1ef1, 0x01c97, 0x13},
};

char bgmfile[FILE_CNT][14]={
	"th09tr_01.mid",
	"th09tr_02.mid",
	"th09tr_03.mid",
	"th09tr_04.mid",
	"th09tr_05.mid",
	"th09tr_06.mid",
	"th09tr_07.mid",
};

void decode1(char *, char *, int, int);
void decode2(char *, char *, int, int);
int bit(char **, int *, int);

int main(){
	FILE *datf,*bgmf;
	char *enc, *dec1, *dec2;
	int i;

	datf=fopen("th09tr.dat","rb");
	if(datf==NULL){
		printf("th09tr.dat not found.");
		return 0;
	}

	enc  = (char *)malloc(0x4ADE20 * 2);
	dec1 = (char *)malloc(0x4ADE20 * 2);
	dec2 = (char *)malloc(0x4ADE20 * 2);

	if(enc == NULL || dec1 == NULL || dec2 == NULL){
		printf("Can't allocate memory\n");
		return 0;
	}

	for(i=0; i<FILE_CNT; i++){
		printf("Create %s ... \n",bgmfile[i]);

		bgmf = fopen(bgmfile[i],"wb");
		if(bgmf == NULL){
			printf("Can't open file %s\n", bgmfile[i]);
			break;
		}
		fseek(datf,bgmtable[i][0],SEEK_SET);
		fread(enc,1,bgmtable[i][1],datf);

		decode1(enc,  dec1, bgmtable[i][1], bgmtable[i][2]);
		decode2(dec1, dec2, bgmtable[i][2], bgmtable[i][3]);

		if(fwrite(dec2,1,bgmtable[i][2]-0x04,bgmf) == 0){
			printf("Can't write file %s\n", bgmfile[i]);
			fclose(bgmf);
			break;
		}
		fclose(bgmf);
	}
	free(enc);
	free(dec1);
	free(dec2);
	fclose(datf);
	
	return 0;
}

//0x80Pʂ̕ёւAXor̕
void decode2(char *p1, char *p2, int size, int key){

	int i;
	int cut = 0x80;
	int m_size = 0x2800;
	unsigned char xor = 0x35;
	unsigned char add = 0x97;
	char *pt;

	p1   += 0x04;
	size -= 0x04;

	key  += size & 0x01;
	size -= key;

	while(size > 0 && m_size > 0){
		if(size < cut)
			cut = size;
		
		pt = p2 + (cut - 1);
		for(i=0; i<(cut+1)/2; i++){
			*pt = *p1++ ^ xor;
			xor = (xor + add) & 0xff;
			pt -= 2;
		}

		pt = p2 + (cut - 2);
		for(i=0; i<cut/2; i++){
			*pt = *p1++ ^ xor;
			xor = (xor + add) & 0xff;
			pt -= 2;
		}
		size   -= cut;
		p2     += cut;
		m_size -= cut;
	}

	size += key * 4;
	for(i=size; i>0; i--){
			*p2++ = *p1++;
	}
}


//ky@
void decode1(char *p1, char *p2, int d1, int d2)
{
	char *dic_p = p2 + 0x630041;
	char *e_p   = p2 + d2;
	char buf;

	int adr;
	int cnt = 1;
	int chk = 0x100;
	int i,j;

	while(p2 < e_p){

		if( bit(&p1, &chk, 1) ){

			buf = bit(&p1, &chk, 8);

			*p2++ = buf;
			*(dic_p + cnt) = buf;
			cnt = (cnt + 1) & 0x1fff;
		}
		else {

			adr = bit(&p1, &chk, 13);
			j   = bit(&p1, &chk, 4);

			for(i=0; i<=j+2; i++){
				buf = *(dic_p + adr);
				adr = (adr + 1) & 0x1fff;

				*p2++ = buf;
				*(dic_p + cnt) = buf;
				cnt = (cnt + 1) & 0x1fff;
			}
		}
	}
}

int bit(char **p1, int *chk, int turn)
{
	int i, result=0;

	for(i=0; i<turn; i++){
		result <<=1;

		*chk >>= 1;
		if(*chk == 0x00){
			*chk = 0x80;
			*p1 = *p1 + 1;
		}

		if(**p1 & *chk)
			result |= 0x01;
	}

	return result;
}
